
Redmine - Feature #2024

gantt chart editing

2008-10-12 01:54 - Hiroyuki Yoshioka

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Gantt Estimated time: 0.00 hour

Target version:    

Resolution:    

Description

This is a patch to edit gantt chart.

You can move a bar and change start or due date.

Related issues:

Related to Redmine - Feature #15396: Move related tasks in Gantt New

Has duplicate Redmine - Feature #1806: Gantt Editing Closed 2008-08-23

Has duplicate Redmine - Feature #3062: Interactive gantt chart feature Closed 2009-03-27

Follows Redmine - Feature #6276: Gantt Chart rewrite Closed 2010-09-03

History

#1 - 2008-12-06 18:08 - Ludovic Gasc

+1

#2 - 2008-12-06 21:21 - Markus Knittig

+1

#3 - 2008-12-25 03:17 - Mischa The Evil

I've been experimenting with this patch on a checkout of Redmine trunk r2167. It seems like it could be a great improvement, though this patch is not

yet feature complete:

the view doesn't handle issues which have been assigned to a target version (which itself has a set due date) but are missing a specific start-

and/or due date. Such results in an error like this:

Processing IssuesController#gantt (for 192.168.1.2 at 2008-12-25 01:30:30) [GET]

  Session ID: a8fdc48242b0d8a394ae19afefca3730

  Parameters: {"project_id"=>"test1", "action"=>"gantt", "controller"=>"issues"}

Rendering template within layouts/base

Rendering issues/gantt.rhtml

ActionView::TemplateError (You have a nil object when you didn't expect it!

The error occurred while evaluating nil.<=) on line #271 of issues/gantt.rhtml:

268: top = headers_height + 10

269: @gantt.events.each do |i| 

270:   if i.is_a? Issue 

271:        i_left, i_width, l_width, d_width = get_position(i, @gantt.date_from, @gantt.date_to, zoom)

272:     %>

273:   <div id="ev_<%=i.id%>" style="position:absolute;left:<%= i_left %>px;top:<%= top %>px;padding-top:3

px;height:18px;width:<%= i_width+100 %>px;" class="handle">

274:     <div id="task_todo_<%=i.id%>" style="float:left; width:<%= i_width %>px;" class="task task_todo">

 </div>

which (for the due date only) can be fixed by using i.due_before instead of i.due_date in the view for these issues (see changes in r1455).

followup of above: the view should handle issues with an assigned target version (which itself has a set due date) by using the due date from the

targetted version as the fixed due date of the issue (so without calendar link).

the gantt-objects shouldn't be draggable (to the right) when the issue due date is fixed by an assigned target version's due date. Only the start

date should be changable by dragging it to the left.

issue's due dates should be marked when it's linked against a target version's due date.

Looking at the above sum I'm guessing that I am probably able to implement the changes myself in some time. Probably most needed enhancements

could be made by adding some nested if i.due_date?-structures. I'll see what I can do...

Greetings...
#4 - 2009-02-18 03:17 - Hiroyuki Yoshioka

- File gantt-editting-r2478.patch added

I'm sorry for the delay in my reply.

I overlooked your comment.

How about this patch?

The changes are below:

The view can handle issues which have been assigned to a target version (which itself has a set due date).

Issue's version is displayed when it's linked against a target version's due date.

Check issue's dependencies and update other bar when the date is changed.

#5 - 2009-02-18 20:04 - Mischa The Evil

Hiroyuki Yoshioka wrote:

I'm sorry for the delay in my reply.

I overlooked your comment.

 Never mind. Appreciate your efforts on this issue already... ;)

How about this patch?

The changes are below:

The view can handle issues which have been assigned to a target version (which itself has a set due date).

Issue's version is displayed when it's linked against a target version's due date.

Check issue's dependencies and update other bar when the date is changed.

 This seems to be solving most (or all) issues I've ran into when testing this. As soon as I have my devel-deployment updated to current trunk

(currently stuck at r2167) I'll start some more tests on this patch...

#6 - 2009-02-27 02:54 - Enderson Maia

+1

Maybe you should get some ideas from the ClokingIT code, if the license permits it.

Code : http://wiki.clockingit.com/wiki:source

Screenshots : http://www.clockingit.com/screenshots

There's a video showing the interactive gantt chart.

#7 - 2009-03-30 01:07 - Mischa The Evil

Mischa The Evil wrote:

Hiroyuki Yoshioka wrote:

How about this patch?

The changes are below:

The view can handle issues which have been assigned to a target version (which itself has a set due date).

Issue's version is displayed when it's linked against a target version's due date.

Check issue's dependencies and update other bar when the date is changed.

 This seems to be solving most (or all) issues I've ran into when testing this. As soon as I have my devel-deployment updated to current trunk

(currently stuck at r2167) I'll start some more tests on this patch...

 I've tested the updated patch against trunk at r2641 and it seems to work (very) fine by now. All the mentioned issues are handled.

Only one last thing that comes up by now: the changes in the issue's start-/due-dates aren't reflected as issue-journals [ - sic - ] project-activity.

HTH... ;-)

#8 - 2009-04-04 10:09 - Hiroyuki Yoshioka

- File gantt-editting-r2645.patch added
Mischa The Evil wrote:

I've tested the updated patch against trunk at r2641 and it seems to work (very) fine by now. All the mentioned issues are handled.

Only one last thing that comes up by now: the changes in the issue's start-/due-dates aren't reflected as issue-journals [ - sic - ] project-activity.

 Hi, thank you for your test!

How about this patch?

#9 - 2009-04-09 00:18 - loic Le Gallou

great feature ! one small bug : after moving an issue, dates are correctly updated (in the second column), but in the calendar the date is the previous

value (not the new one).

It would be also nice to be able to change the start and end of an issue directly with the mouse.

#10 - 2009-04-18 09:20 - Hiroyuki Yoshioka

- File gantt-editting-r2671.patch added

loic Le Gallou wrote:

great feature ! one small bug : after moving an issue, dates are correctly updated (in the second column), but in the calendar the date is the

previous value (not the new one).

It would be also nice to be able to change the start and end of an issue directly with the mouse.

 Thank you for the bug report.

Could you try this new patch?

#11 - 2009-04-19 11:39 - Hiroyuki Yoshioka

- File gantt-editting-r2671-2.patch added

Hiroyuki Yoshioka wrote:

Thank you for the bug report.

Could you try this new patch?

The patch has some bugs...

It does't show error messages.

It observes version objects.

Here is the new patch.

#12 - 2009-04-28 22:13 - Harold Uribe

Hello, how to install this patch in a Bitnami Redmine Stack in Windows??? I download a GNU Patch Utility but fail.

#13 - 2009-04-29 18:26 - loic Le Gallou

- File pb-gantt-edit-r2671.PNG added

Hi,

I've tried this new version (on redmine trunk revision r2671) but I face some display troubles of the gantt chart (see screenshot)

#14 - 2009-07-09 01:11 - Yohann Monnier

The same for me.

All design is broken in the gantt view.

#15 - 2009-07-10 15:21 - Hans Kazan

Yohann Monnier wrote:

The same for me.

All design is broken in the gantt view.
 I love the idea and the possibilities but it lacks stability on r2671 it works.

On other versions its broken by updates and other plugins.

Is there a chance that this would make it to the core? Or a plugin if that is not feasible?

#16 - 2009-07-11 05:48 - Hiroyuki Yoshioka

Yohann Monnier wrote:

The same for me.

All design is broken in the gantt view.

 Hmm..

I tested gantt-editting-r2671-2.patch on redmine trunk revision r2671 and r2819, but it works for me.

What kind of issues do you create?

And could you send a html source when the gantt chart is broken?

#17 - 2009-08-12 13:38 - Andrey Kostrov

- File pb-gantt-edit_404err.jpg added

Hiroyuki Yoshioka wrote:

This is a patch to edit gantt chart.

You can move a bar and change start or due date.

 The feature is really great,

but when I use the patch on Redmine 0.8.4 (Bitnami Redmine Stack 0.8.4-0), and try to move a bar, I get this:

 pb-gantt-edit_404err.jpg 

I did try to remove all the plugins, but it's the same.

Additionally, on Bitnami Redmine Stack 0.8.4-1 the chart is broken as on pb-gantt-edit-r2671.PNG.

Is there any solution?

#18 - 2009-10-09 11:09 - Andrew Rudenko

any news for the latest r2904?

It would be great to have the patch for the latest revision.

thanks in advance!

#19 - 2009-10-17 18:37 - Hiroyuki Yoshioka

- File gantt-editting-fixed-display-trouble.patch added

Andrey Kostrov wrote:

I did try to remove all the plugins, but it's the same.

Additionally, on Bitnami Redmine Stack 0.8.4-1 the chart is broken as on pb-gantt-edit-r2671.PNG.

Is there any solution?

 I'm sorry for the delay in my reply.

I found a bug finally.

Could you try this new patch?

I tested on Bitnami Redmine 0.8.5.

#20 - 2009-10-17 18:46 - Hiroyuki Yoshioka

- File gantt-editting-r2924.patch added

Andrew Rudenko wrote:

any news for the latest r2904?

It would be great to have the patch for the latest revision.

thanks in advance!
 Hi, I made a patch for the r2924.

See the file gantt-editting-r2924.patch.

#21 - 2009-10-18 21:46 - Andrew Rudenko

Hiroyuki Yoshioka wrote:

Hi, I made a patch for the r2924.

See the file gantt-editting-r2924.patch.

 Thanks a lot! It is I needed for.

#22 - 2009-10-20 03:13 - Eric Davis

Just wanted to let everyone here know, I have a huge rewrite of the Gantt chart I'm working on.  It has a bunch of new features and I removed a lot of

duplicated code (HTML, PDF, and PNG rendering where duplicated).  It's still being tested and could use some optimization but I'm hoping to have it

ready in the next month or two.

#23 - 2009-10-20 17:20 - Hiroyuki Yoshioka

Eric Davis wrote:

Just wanted to let everyone here know, I have a huge rewrite of the Gantt chart I'm working on.  It has a bunch of new features and I removed a

lot of duplicated code (HTML, PDF, and PNG rendering where duplicated).  It's still being tested and could use some optimization but I'm hoping

to have it ready in the next month or two.

 It sounds great.

I'm looking forward to the release.

:)

#24 - 2009-11-30 12:40 - Andrew Rudenko

Eric Davis wrote:

Just wanted to let everyone here know, I have a huge rewrite of the Gantt chart I'm working on.  It has a bunch of new features and I removed a

lot of duplicated code (HTML, PDF, and PNG rendering where duplicated).  It's still being tested and could use some optimization but I'm hoping

to have it ready in the next month or two.

 sure, sounds very good,

waiting for the release :)

as for patch, it stopped to redraw chart when changed due_date from calendar element, and it is redrawn after refreshing the page with F5.

#25 - 2010-01-29 23:24 - loic Le Gallou

Eric Davis wrote:

Just wanted to let everyone here know, I have a huge rewrite of the Gantt chart I'm working on.  It has a bunch of new features and I removed a

lot of duplicated code (HTML, PDF, and PNG rendering where duplicated).  It's still being tested and could use some optimization but I'm hoping

to have it ready in the next month or two.

 One remark about the (nice) plugin initialised by Hiroyuki Yoshioka : when moving an issue with the mouse, the modification is done immediately, so

the issue's history is updated. This is fine if you are sure of what you are doing (for example task planning is already fixed and you just apply it in

redmine). My point of view is that the gantt char edition feature using the mouse is especially usefull when you are trying to find the best planning for

your tasks. In that case, you'll probably have to move each issue several times before reaching a satisfying planning. This will cause a huge list of

"date changement" in the history, which is not relevant. My suggestion is to have a "validate" button which will apply the Gantt Chart modifications

when we are satisfied with the planning.

This is a user feedback, I don't know if it easy to do ;-)

#26 - 2010-02-05 10:59 - Guillaume Pellegrin

Eric Davis wrote:

Just wanted to let everyone here know, I have a huge rewrite of the Gantt chart I'm working on.  It has a bunch of new features and I removed a

lot of duplicated code (HTML, PDF, and PNG rendering where duplicated).  It's still being tested and could use some optimization but I'm hoping

to have it ready in the next month or two.

 Hi Eric,
I hope you are doing well and successfully handle your multiple redmine projects...

Did you manage to move forward on this one? Hiroyuki's patch is now a vital feature for my team but I struggle each time I want to upgrade Redmine

trunk, so your support in this (especially in including it in the trunk?) would be great...

Thanks for feedback!

#27 - 2010-02-05 14:04 - Andrew Rudenko

Guillaume Pellegrin wrote:

Eric Davis wrote:

Just wanted to let everyone here know, I have a huge rewrite of the Gantt chart I'm working on.  It has a bunch of new features and I

removed a lot of duplicated code (HTML, PDF, and PNG rendering where duplicated).  It's still being tested and could use some

optimization but I'm hoping to have it ready in the next month or two.

 Hi Eric,

I hope you are doing well and successfully handle your multiple redmine projects...

Did you manage to move forward on this one? Hiroyuki's patch is now a vital feature for my team but I struggle each time I want to upgrade

Redmine trunk, so your support in this (especially in including it in the trunk?) would be great...

Thanks for feedback!

 sure Eric, it would be very appreciated.

--andrew

#28 - 2010-02-06 13:39 - Eric Voisard

I just realized how useful this feature would be during the planning of a project, especially if, as Loic suggested, it was possible to commit all changes

at once when we're happy with actual plan. Hiroyuki, would it be possible to include this feature?

As for Eric's rewrite vs Hiroyuki's patch: would both be compatible, mutually-exclusive or redundant?

As always, thanks for all your work, guys!

Eric

#29 - 2010-02-07 02:57 - Hiroyuki Yoshioka

loic Le Gallou wrote:

One remark about the (nice) plugin initialised by Hiroyuki Yoshioka : when moving an issue with the mouse, the modification >is done

immediately, so the issue's history is updated. This is fine if you are sure of what you are doing (for example >task planning is already fixed and

you just apply it in redmine). My point of view is that the gantt char edition feature >using the mouse is especially usefull when you are trying to

find the best planning for your tasks. In that case, you'll >probably have to move each issue several times before reaching a satisfying planning.

This will cause a huge list of "date >changement" in the history, which is not relevant. My suggestion is to have a "validate" button which will

apply the Gantt >Chart modifications when we are satisfied with the planning.

 Thank you for your suggestion.

It is good idea.

Eric Voisard wrote:

I just realized how useful this feature would be during the planning of a project, especially if, as Loic suggested, it was possible to commit all

changes at once when we're happy with actual plan. Hiroyuki, would it be possible to include this feature?

 It wouble be possible, but I think I should wait for Eric's rewrite.

#30 - 2010-02-09 03:27 - Eric Davis

Eric Voisard wrote:

As for Eric's rewrite vs Hiroyuki's patch: would both be compatible, mutually-exclusive or redundant?

 They would probably work together but I've rearranged so much of the Gantt chart that there will be some merging needed.

#31 - 2010-02-10 16:00 - Yohann Monnier

Eric Hulser Davis : Where can i find your rewrite ? is this plugin will be integrated to the core of redmine ?

#32 - 2010-02-16 17:08 - S Reid
Eric Hulser Davis : Any news on the likely date of the new gantt chart and what the features will be ?

#33 - 2010-02-19 06:24 - Eric Davis

- Category set to Issues

Yohann Monnier wrote:

Eric Hulser Davis : Where can i find your rewrite ? is this plugin will be integrated to the core of redmine ?

 It's in a client's Redmine so I can easily extract it.  It is a core modification, there isn't any way to do this from a plugin except for rewriting the core

classes.

Sandy Reid wrote:

Eric Hulser Davis : Any news on the likely date of the new gantt chart and what the features will be ?

 No likely date but I think we are going to extract some of their private features in March so I can try to include the gantt changes with them. (We have

a bunch of new LDAP features coming in too)

#34 - 2010-04-15 14:54 - Carlos Calvo

- File gantt_edit_0.9.3_stable_3671.patch added

Here it goes an update of the patch for the latest stable version, 0.9.3.

Kind of useful this gantt editting specially for PM!

#35 - 2010-05-11 16:15 - Andrew Rudenko

what about development (trunk) branch?

starting from r3695 gantts moved into the separated controller.

can anyone help to adopt the latest patch for trunk?

I tried but had no success. I have a leak of skills.

Any help will be appreciated.

Regards,

--andrew

#36 - 2010-05-20 18:04 - Andrew Rudenko

any lucks so far?

#37 - 2010-05-25 13:47 - Ben Senior

Hi, I'm also very interested in this :-)  I've moved my team over to redmine, using the redmine-sprints plugin... but the lack of Gantt chart planning

means I'm still dependent on GanttProject :(  Looking forward to hearing new news!

#38 - 2010-05-29 17:57 - Hiroyuki Yoshioka

- File gantt_edit_r3764.patch added

Andrew Rudenko wrote:

any lucks so far?

 Hi, Andrew.

Try this patch.

See the file gantt-editting-r3764.patch.

#39 - 2010-05-31 14:19 - Andrew Rudenko

Hiroyuki Yoshioka wrote:

Hi, Andrew.

Try this patch.

See the file gantt-editting-r3764.patch.

 Hi, Hiroyuki.
Your patch is perfect! It has been easily applied and tested. Your help appreciated much.

Thanks,

--andrew

Mood: thankful & happy

#40 - 2010-09-26 23:41 - Eric Davis

Did a quick review of gantt_edit_r3764.patch:

missing tests

logic in the controller should be moved to the moved

javascript assumes Redmine is running at the domain root and uses a hardcoded url to '/issues'.  Should use the Rails url helpers

routing doesn't follow the REST patterns

#41 - 2010-10-03 15:13 - Mischa The Evil

- Category changed from Issues to Gantt

#42 - 2011-01-18 03:01 - seunghyun yi

Hi, Hiroyuki. and Eric

I want this Patch in Version 1.0.2 or 1.1.0.

How do this Patch?

and using want forever this Patch in next version

(ex : 1.2.x, 1.3.x, 2.0.x etc...)

#43 - 2011-01-18 03:33 - seunghyun yi

- Assignee set to Hiroyuki Yoshioka

Let me ask you one more thing.

When I modify Work schedules on Gantt Chart it updates the whole Redmine schedule real time. Is there an way to throw in an 'apply' button so the

schdule only updates when I click it?

#44 - 2011-01-23 14:00 - Hiroyuki Yoshioka

Hi, seunghyun.

I will try to create a patch for 1.1.0.

Wait for several days.

Hi, Eric.

Thank you for your review.

I'm looking your new code.

Your rewrite is very good :)

#45 - 2011-01-23 16:46 - Lars P.

Oh,damn

I so want to see this asa a part of the core of Redmine.

One of the few things RM lacks before beeing a complete project management web application.

#46 - 2011-01-23 17:27 - Yohann Monnier

I agree. This should be completed by some features (arrow between tasks for dependencies) and inserted in the core of redmine. This is a must have

!

Thank you for your work !

#47 - 2011-02-13 16:08 - Hiroyuki Yoshioka

- File gantt_edit_v1-1-0.patch added

I made a patch for version 1.1.0.

See the file gantt_edit_v1-1-0.patch.

There are many changes internally.
Bug reports will be appreciated.

I agree. This should be completed by some features (arrow between tasks for dependencies) and inserted in the core of redmine. This is a must

have !

 Thank you, Yohann.

I hope it will be someday.

#48 - 2011-02-13 16:36 - Hiroyuki Yoshioka

seunghyun yi wrote:

Let me ask you one more thing.

When I modify Work schedules on Gantt Chart it updates the whole Redmine schedule real time. Is there an way to throw in an 'apply' button so

the schdule only updates when I click it?

 I'll think about it.

But it is a little bit difficult.

The problem is the method of caching data before apply without updating database,

and the collision with other users operation.

#49 - 2011-02-22 10:46 - Chris Darts

I've just run this patch against v1.1.1 as it works perfectly. Great addition to include show the start and due date as columns in the Gantt chart as well.

My only other recommendation would be to have a column to show Assignee (there may be a plugin or patch already that I'm not aware of).

The other outstanding improvement would be to allow administrators to specify the working week + holidays to avoid tasks getting scheduled on

weekends or other non-working days. I see this is being suggested with feature #2161.

Thanks again for this great patch!

#50 - 2011-02-23 09:09 - Chris Darts

I've just looked through the roadmap for v1.1.2 and v1.2 and don't see this being incorporated into the core Redmine system. For me I feel this is a

must have for anyone wishing to replace their existing project scheduling system and move over to Redmine and would strongly recommend it

becoming part of the core application.

I'm fairly new to Redmine and these forums so can anyone explain how this review and incorporation process works.

Thanks.

#51 - 2011-02-24 15:21 - Luis Serrano Aranda

If any task don't have due data this patch don't show the next dates, I test with redmine 1.1.1

#52 - 2011-02-24 15:26 - Luis Serrano Aranda

In brief I put 2 new taks in the first In the two issues I write only the start date, and looking the Gantt I only look the start date of the first issue

#53 - 2011-02-24 15:42 - Luis Serrano Aranda

If I try to move a bar and the task has not been created by me, the error message shows nothing and the task does not return to its position.

Tanks for your work

#54 - 2011-02-26 17:16 - Hiroyuki Yoshioka

- File gantt_edit_v1-1-1.patch added

Luis Serrano Aranda wrote:

If I try to move a bar and the task has not been created by me, the error message shows nothing and the task does not return to its position.

 Thank you for your reports.

It's a bug. Permission error occurs internally.

Try the new patch.

You can change dates only if you have permission to edit issues.

#55 - 2011-02-28 13:30 - Chris Darts

- File gantt_edit_v1-1-1_error.png added
I've just applied the latest patch (v1-1-1), but it seems there are still a few issues with it.

When changing the start or due date on the Gantt interface it displays a warning pop-up with a blank message (see screenshot attached). After

clicking the 'OK' button, the Gantt chart then moves the bar to the wrong place in time. If you then refresh the screen it accepts the change of date

and moves it back to the correct position. However, if you then click on the start or due date (depending which one you just changed) then it has the

previous, incorrect date highlighted.

In short, it seems the change of date is being saved correctly, but you need to do a manual browser refresh in order for it to be accepted and even

then it's not displaying the correct date in the pop-up calendar.

I really feel this patch is a major addition to Redmine and would love to see these minor issues ironed out if possible.

My other request would be to reduce the width of the column with the start and end date and also include a column with the 'Assignee'.

#56 - 2011-03-05 16:16 - Hiroyuki Yoshioka

- File gantt_edit_2_v1-1-1.patch added

Chris Darts wrote:

I've just applied the latest patch (v1-1-1), but it seems there are still a few issues with it.

 Thank you for you report.

An error occurred when due date of project was out of range for display.

I made the new patch.

My other request would be to reduce the width of the column with the start and end date and also include a column with the 'Assignee'.

 Thank you for your suggestion.

I will consider about it.

#57 - 2011-03-08 14:44 - Chris Darts

I have applied the latest patch 'gantt_edit_2_v1-1-1.patch' and completed some initial testing.

It has fixed the problem with the pop up error box, which is good. However, when changing either a start or due date it automatically

refreshes the screen and displays the dates incorrectly on the gantt chart. If I then manually refresh then it moves them to the correct date, so

obviously it's saving it to the database OK.

The other problem is that I have a number of inter related tasks, which precede and follow one another. When changing the due date through the

gantt interface, it doesn't re-adjust the dates on the related issues correctly. However, when changing the start date it does re-adjust the related

issues correctly. In the previous version both changing the start date or the due would work fine, so it seems this last bug is something introduced in

the latest version.

I have just tried the new 'Better Gantt Chart' plugin in conjunction with this patch and it seems to have resolved the problem with re-calculating dates

for related issues. However, there are some compatibility issues between the plugin and this patch (see 

http://www.redmine.org/boards/3/topics/22288).

I hope this helps. I'm happy to give further feedback if you need. I am currently running 'Redmine 1.1.2.stable.5022 (MySQL)'

I really like this plugin and I can see it adds a huge improvement to Redmine. Please let me know if there is anything else I can do to assist the

development of this plugin. As I mentioned in my forum post (22288) it would be great if the authors of this patch and the 'Better Gantt Chart' plugin

could join forces somehow.

#58 - 2011-03-08 21:36 - Alexey Kuleshov

Chris Darts wrote:

I have just tried the new 'Better Gantt Chart' plugin in conjunction with this patch and it seems to have resolved the problem with re-calculating

dates for related issues. However, there are some compatibility issues between the plugin and this patch (see 

http://www.redmine.org/boards/3/topics/22288).

 Chris, as I replied to the forum post I have released a new version of the plugin which hopefully solves most compatibility issues.

As I mentioned in my forum post (22288) it would be great if the authors of this patch and the 'Better Gantt Chart' plugin could join forces

somehow.

 I'm all for it. I will continue update the plugin for compatibility with new versions of the patch.
#59 - 2011-03-09 08:09 - Chris Darts

Thanks for your quick response on this Alexey. As reported in the plugin forum post (http://www.redmine.org/boards/3/topics/22288) the new version

of the plugin has resolved a number of the bugs, which is great.

Hiroyuki,

When using patch #2024 with the 'Better Gantt Chart' plugin, the current outstanding issues with the patch are as follows:

1. when changing either a start or due date it automatically refreshes the screen and displays the dates incorrectly on the gantt chart. If I then

manually refresh then it moves them to the correct date, so obviously it's saving it to the database OK.

2. when you try to change the start or due date through the Gantt chart interface using the date picker, it automatically updates the date value (and

therefore the bars on the Gantt chart) when you move between months, even if you haven't actually selected a date.

It would be great if it is possible to fix these 2 outstanding issues. I really feel that this patch, combined with the plugin greatly improve the standard

functionality of the Gantt chart in Redmine. As Ivan Cenov added (http://www.redmine.org/boards/3/topics/22288?r=22292#message-22292) it would

be great to see this functionality incorporated into the core Redmine system at some point in the future.

Thanks,

Chris

#60 - 2011-03-09 10:15 - Luis Serrano Aranda

Is is possible to make this in a plugin, i think is better to update redmine.

Thanks

#61 - 2011-04-15 07:22 - Masayuki Shibata

Yoshioka-san,

When using gantt_edit_2_v1-1-1.patch, the PNG export function with clicking right-under "PNG" link in gantt chart gives us "Internal Error".

The function this patch itself works fine. greeeeat!

Just I want to know, this is our own problem or not?

Would you tell me its OK or not in your environment.

Regards,

#62 - 2011-04-22 13:57 - Masayuki Shibata

- File gantt.rb added

For the time being...

I made change to \lib\redmine\helpers\gantt.rb.

Sorry, but the code is rather redundant.

Anyway, the PNG export function for Gantt chart works now.

Attention:

line 460-461 was changed to fix another problem to show Japanese letter correctly.

#63 - 2011-04-30 04:25 - Toshi MARUYAMA

- Due date deleted (2010-09-04)

- Start date deleted (2010-09-04)

#64 - 2011-05-13 10:42 - Masayuki Shibata

I have done small changes to avoid getting illegal html format output.

like following...

I am not sure everybody knows this problem or not.

Anyway, in {redmine}\lib\redmine\helpers\gantt.rb

def calendar_for_issue(issue, options)
  # Skip issues that don't have a due_before (due_date or version's due_date)

  if issue.is_a?(Issue) && issue.due_before

    case options[:format]

    when :html

+     @calendars << "<div style='position: absolute;line-height:1.2em;height:16px;top:#{options[:top]}px;left:

4px;overflow:hidden;'>" 

      start_date = issue.start_date

      if start_date

-       @calendars << "<div style='position: absolute;line-height:1.2em;height:16px;top:#{options[:top]}px;lef

t:4px;overflow:hidden;'>" 

        @calendars << "<span id='i#{issue.id}_start_date_str'>" 

        @calendars << format_date(start_date)

        @calendars << "</span>" 

        @calendars << "<input type='hidden' size='12' id='i#{issue.id}_hidden_start_date' value='#{start_date}

' />" 

-       @calendars << "<input type='hidden' size='12' id='i#{issue.id}_start_date' value='#{start_date}'>#{vie

w.g_calendar_for('i' + issue.id.to_s + '_start_date')}" 

+       @calendars << "<input type='hidden' size='12' id='i#{issue.id}_start_date' value='#{start_date}' />#{v

iew.g_calendar_for('i' + issue.id.to_s + '_start_date')}" 

        @calendars << observe_date_field("i#{issue.id}", 'start')

      end

      due_date = issue.due_date

      if due_date

        @calendars << "<span id='i#{issue.id}_due_date_str'>" 

        @calendars << format_date(due_date)

        @calendars << "</span>" 

        @calendars << "<input type='hidden' size='12' id='i#{issue.id}_hidden_due_date' value='#{due_date}' />

" 

-       @calendars << "<input type='hidden' size='12' id='i#{issue.id}_due_date' value='#{due_date}'>#{view.g_

calendar_for('i' + issue.id.to_s + '_due_date')}" 

+       @calendars << "<input type='hidden' size='12' id='i#{issue.id}_due_date' value='#{due_date}' />#{view.

g_calendar_for('i' + issue.id.to_s + '_due_date')}" 

        @calendars << observe_date_field("i#{issue.id}", 'due')

-       @calendars << "</div>" 

      end

+     @calendars << "</div>" 

    when :image

      #nop

    when :pdf

      #nop

    end

  else

    ActiveRecord::Base.logger.debug "GanttHelper#line_for_issue was not given an issue with a due_before" 

    ''

  end

end

#65 - 2011-05-16 18:23 - steve borgelt

I have applied patched gantt_edit_2_v1-1-1.patch to my 1.1.2 redmine, however I do not see any changes on the 

http://localhost:3000/projects/test/issues/gantt page, nor any arrows to adjust on the bar.

Do I need to wait for a 1.1.2 patch? Is there anything else that needs to be done on a vanilla 1.1.2 redmine besides the patch file?

#66 - 2011-05-18 00:29 - steve borgelt

- File gantt-display.png added

steve borgelt wrote:

I have applied patched gantt_edit_2_v1-1-1.patch to my 1.1.2 redmine, however I do not see any changes on the 

http://localhost:3000/projects/test/issues/gantt page, nor any arrows to adjust on the bar.

 Nevermind, I'm thinking of being able the start and ends of the bar :P I see that the entire bar slides and now there is a start and end calender picker.

Couple of Issues/Bugs

#1. The Gantt Project/Issue line items don't render properly in IE9, not sure if your issue or general redmine gantt issue. See attachment.

It seem that by default, IE9 renders the page in IE 9 Compaibility view. Although the Titles are missing, I can properly slide the gantt bar.

#2. When in regular IE9 rendering, the line items display properly, however the bar no longer slides. This must be why IE9 tries to render using

Compatability view by default.

#67 - 2011-05-18 14:33 - Etienne Massip
See #7807.

#68 - 2011-05-20 10:49 - Chris Darts

- File gantt_edit_5_v1-1-1.patch added

I have attached is a newer version (v5) of this patch file from the developer. This resolves a few small bugs found in previous versions.

This patch can also work in conjunction with the Better Gantt Chart plugin (http://www.redmine.org/plugins/redmine_better_gantt_chart) for additional

functionality. If you are using both the patch and the plugin then you will need the 'patch #2024' branch of the plugin.

I have tested both of these on Redmine v1.1.3 and they seem to work fine.

#69 - 2011-05-21 15:25 - Hiroyuki Yoshioka

Thank you, Chris.

The patch solves the below issues.

A popup dialog is displayed when due date of a project is out of range.

When changing either a start or due date, it automatically refreshes the screen and displays the dates incorrectly in some cases.

It tries to automatically change the start or due date when changing months on the date picker,

without selecting a specific date.

I couldn't have made the patch without your cooperation.

#70 - 2011-05-29 13:13 - Hiroyuki Yoshioka

- File gantt_edit_v1-1-2.patch added

I made a new patch.

This patch solves the following problem.

When changing a start or due date of a sub-task, it doesn't correctly show the adjusted start or due date for the parent task.

I have tested on version 1.1.2.

#71 - 2011-05-29 13:25 - Hiroyuki Yoshioka

When changing a start or due date of a sub-task, it doesn't correctly show the adjusted start or due date for the parent task.

And the patch solves the following problem, too.

the PNG export function with clicking right-under "PNG" link in gantt chart gives us "Internal Error".

Shibata-san,

thank you for your cooperation.

#72 - 2011-07-28 15:39 - Wesley Buchanan

Hi,

Are there any plans to update this to work with version 1.2?  Currently we are using the patch with version 1.1.3 and it works very well and I would like

to update Redmine to 1.2 however we don't want to lose this functionality.

#73 - 2011-08-26 18:03 - Aleksey Dubov

+1

#74 - 2011-09-14 20:53 - alan blount

+1 - I'd love to get this updated too

#75 - 2011-09-14 22:54 - Alex Voronko

+1 too

#76 - 2011-10-04 05:02 - Ian Wojtowicz

+1 This one feature alone would push Redmine far ahead of the pack. This would really make it an awesome software development tracking system.

And open source to boot!
#77 - 2011-10-13 15:41 - Sebastian Lüdtke

+1 too

This feature working for new version would be very nice!

#78 - 2011-10-20 21:57 - Mitsuo Ohtsuka

- File gantt-chart-editing-v1-2-1-src.zip added

+1 This should be a great feature for the future release of Redmine!

I've just tried making this patch work with Redmine 1.2.1 on Windows Vista and it seems to work fine so far.

I attached the source files of Redmine 1.2.1 which I modified, just for reference. (Sorry it's NOT a patch file...)

Good luck!

#79 - 2011-10-25 08:55 - Siegfried Vogel

+1

#80 - 2011-11-01 15:57 - Anonymous

To fix the PNG export 500 error:

1. Open \lib\redmine\helpers\gantt.rb

2. Line 579 gc.line(x, headers_heigth, x, headers_heigth + g_height-1)

3. Update to gc.line(x, headers_height, x, headers_height + g_height-1)

Is there any plan to include relationships between issues? Haven't been able to get this working yet.

Thank you

#81 - 2011-12-14 20:49 - Jop van Raaij

+1 Looking for this feature!

#82 - 2012-01-26 12:57 - Support IBITEK

Hello,

I saw sources is that they are functional or is even the development period? Demand is still at 0% ?

What is the procedure for testing and installation?

#83 - 2012-02-17 17:48 - Humberto Roca

+1

Really, to have and editable GANTT chart is something that would make REDMINE one of the best tools for Project management. It would be very

appreciated to have this within the release version soon. I don't know if there is a better way for pushing for this idea.

#84 - 2012-05-02 18:14 - Gauthier Delamarre

same for me - drag'n drop support for Gantt charts is THE killer feature Redmine is currently missing... for my day to day work, it's really frustrating

having to edit manually n tasks when I need to postpone one or another task in a project...

unfortunately, as a PHP specialist, I cannot help working on this, but I wish I could!

#85 - 2012-05-22 14:26 - Jacq Jacq

+1 !

#86 - 2012-06-12 10:31 - Ton  Nguyen

This is really such a great function! I tried to patch 'gantt_edit_v1-1-2.patch' on both Redmine v1.3.2 & v1.4.3, but it seems not work, could you please

have a check? Thank you so much!

#87 - 2012-06-16 02:34 - Jun NAITOH

- File gantt_edit_v1-3-3.patch added

+1

I've just tried making this patch work with Redmine 1.3.3 on CentOS 6 and it seems to work fine so far.

I attached the patch files of Redmine 1.3.3 from note-78 and note-80 without config/routes.rb.

I can not understand the necessity of correcting config/routes.rb, sorry.
#88 - 2012-06-16 03:14 - Toshi MARUYAMA

- Assignee deleted (Hiroyuki Yoshioka)

#89 - 2012-06-16 03:23 - Toshi MARUYAMA

- Tracker changed from Patch to Feature

#90 - 2012-06-16 07:06 - Toshi MARUYAMA

- File gantt_edit_v1.4.3.patch added

This is a patch for 1.4.3.

#91 - 2012-06-16 07:56 - Toshi MARUYAMA

- File gantt_edit-trunk-r9835.diff added

This is a patch for trunk r9835.

#92 - 2012-06-16 08:09 - Toshi MARUYAMA

There is no test. You need to add tests.

source:tags/2.0.2/test/unit/lib/redmine/helpers/gantt_test.rb

source:tags/2.0.2/test/unit/helpers/application_helper_test.rb

source:tags/2.0.2/test/unit/helpers/issues_helper_test.rb

source:tags/2.0.2/test/unit/issue_test.rb

source:tags/2.0.2/test/functional/gantts_controller_test.rb

#93 - 2012-07-20 13:32 - Anonymous

- File gantt_edit_v1.4.4-ts.patch added

Thank you very much for this great patch.

We have added few small fixes:

Fixed CSS to remove double borders

Lowered width of the dates column (180px), however long dates will not fit now. We are using YYYY-MM-DD format so it's very good for us and

does not take a lot of screen space.

Aligned dates in the date column

If issue does not have a Due date set now it shows "Not set" and a calendar button - no need to open issue details page to set a due date.

For some reason day of week in the columns was printed twice on Redmine 1.4.4, fixed

I've attached a resulting patch for Redmine 1.4.4.

#94 - 2012-07-20 13:38 - Cassiano Monteiro

+1!

Nice patch! Can´t it be included on the next revision of Redmine?

#95 - 2012-07-20 15:39 - Toshi MARUYAMA

- File gantt_edit.trunk-r10055.diff added

This is a patch for trunk r10055 merged note 93 patch.

Cassiano Monteiro wrote:

+1!

Nice patch! Can´t it be included on the next revision of Redmine?

 If you want to include this feature to next major version,

you need to create a patch for trunk and add tests for this feature described at note 92.

#96 - 2012-07-21 00:58 - Terence Mill

+1

#97 - 2012-07-21 17:36 - Toshi MARUYAMA
- File trunk-r10066.diff added

- File stay.png added

- File not-change-color.png added

This is a patch for trunk r10066.

If user who has no right to edit issue move bar,

bar stays and does not return original position.

 stay.png 

If user move bar, "Bug #4" color does not change.

 not-change-color.png 

#98 - 2012-09-14 12:13 - Luis Serrano Aranda

It is possible add this function to the core ?

#99 - 2012-10-18 18:08 - Yoav HaCohen

+1, This function should be in the core.

#100 - 2012-10-28 19:06 - Daniel Felix

+1 from me to add this to the core.

#101 - 2012-10-29 10:08 - Sebastian Hucke

+1, changing due dates for many tickets (e.g. in case of sickness or some new, prioritized customer requirements) is a huge pain in the current

version.

It is definately a "must have" feature! A perfect complement to the excludation of weekends as described in #2161.

#102 - 2012-11-27 22:33 - aud dog

I've just updated to Redmine 2.1.4.stable on rails version 3.2.8 and I'm having the troubles with the gantt charts not recalculating to the correct end

dates.  I see that the dates seems to be correct within the actual issue but not when viewing via the gantt chart.  Is there a fix or patch for this version

to get the gantt chart to work correctly?

#103 - 2012-11-30 16:14 - Frédéric Houbart

Im working on 1.1.1, with Edit V5 1.1.1 patch, and better gantt patch for this version. Im also using Advanced roadmap, but when I add a version,

roadmap work, but not gantt (all tab). If I delete version off my project, gantt appear.

Any help?

#104 - 2013-03-19 17:55 - Daniel Felix

- Subject changed from gantt chart editting to gantt chart editing

An implementation of this would greatly improve the gantt. It would get more importance in Redmine. Hopefully the patches could be ported to 2.3 and

finally find their way to the core.

#105 - 2013-03-19 19:48 - Dipan Mehta

+1. Yes this is a great work. Hoping to see this.

#106 - 2013-03-19 19:57 - Alex Voronko

+1

#107 - 2013-03-20 05:11 - Mischa The Evil

Daniel Felix wrote:

Hopefully the patches could be ported to 2.3 and finally find their way to the core.

 The most important thing that is missing in the patches are the tests. They aren't there and with a feature like this that wouldn't be good...

#108 - 2013-03-20 18:45 - Daniel Felix

This is clear to me. :-)
But first, the functionality must be ensured. After that, we could try to add some tests to it.

#109 - 2013-08-14 14:05 - Babak Khorrami

any plan/news for this feature?

#110 - 2013-09-18 22:10 - Mark Zalavari

Babak Khorrami wrote:

any plan/news for this feature?

 I think it is dead already.

Wish to be wrong, but the guys at EasyRedmine already implemented the feature: http://www.redmine.org/plugins/advanced-drag-drop-gantt

It seems to be awesome, but it is very expensive... it is too much for startup teams...

This is the only reason our team still using Redmine 1.4.7

However we can offer some donation for this project, if somebody can complete it. (And maybe we are not the only one...)

#111 - 2013-10-21 17:43 - olivier musse

Hi

Why not try our redmine client http://www.mana-sys.fr/en/redmineclient. This is an application, not a web plugin, but we include a first version of gantt

chart editing. This is not as powerfull as easy redmine for sure and need some improvement but it works. It is not free but not so expensive. Have a

look.

Olivier

#112 - 2013-12-02 05:08 - Toshi MARUYAMA

- Related to Feature #15396: Move related tasks in Gantt added

#113 - 2014-02-03 13:18 - Roman Lukmanov

Babak Khorrami wrote:

any plan/news for this feature?

 +1

#114 - 2014-03-06 10:40 - Luis Serrano Aranda

+1

#115 - 2014-04-22 12:48 - Toshi MARUYAMA

- Has duplicate Feature #3062: Interactive gantt chart feature added

#116 - 2014-08-25 12:11 - aem34 -

hello,

is there any news for this feature please ?

#117 - 2014-08-25 20:40 - aem34 -

forgive me, but those patches are against which redmine version please ?

are they working with the current 2.4 or 2.5 version ?

#118 - 2015-01-29 14:46 - Ribald Drobens

+1! Good for intuitively rearrange work packages etc

#119 - 2015-02-12 21:00 - Sergio Vitale

Hi everybody, are there any news about this feature? It would be awesome to have it.

Thanks.

#120 - 2016-02-22 13:29 - Vlad Vor

1000+

This is very important feature.
All modern  project systems supporting it.

It's a reason to move from redmine to something else.

#121 - 2018-06-27 08:40 - Anonymous

I would still love to have this feature. Can someone organise to have some developers come together and create a kickstarter or similiar for a shared

funding ?

I would certainly contribute in a meaningful way.

#122 - 2020-02-03 14:57 - michel p

+1000

#123 - 2020-11-27 07:20 - Yuichi HARADA

- File 2024-moving-gantt-bar.patch added

I created a patch that can dynamically change the start date and due date by moving the bar.

You can drag and drop the bar under the following conditions.

1. The only bars that can be moved is the leaf issues.

2. When you move the bar, the parent issues, version, project, related issues, etc. will move in tandem.

3. You can move the bar only when you are displaying a Gantt that can recognize the date by zooming.

#124 - 2021-01-19 07:13 - Mizuki ISHIKAWA

- File test-2024-moving-gantt-bar-patch.gif added

I applied the patch of #2024#note-123 and tried to make it work.

 test-2024-moving-gantt-bar-patch.gif 

#125 - 2021-02-16 08:21 - Yuichi HARADA

- File 2024-moving-gantt-bar-v2.patch added

Mizuki ISHIKAWA wrote:

I applied the patch of #2024#note-123 and tried to make it work.

 Thank you for giving it a try.

Yuichi HARADA wrote:

I created a patch that can dynamically change the start date and due date by moving the bar.

 I incorporated a patch created with #34694#note-3.

#126 - 2021-02-18 02:43 - Yuichi HARADA

- File 0001-Moving-gantt-bar.patch added

- File 0002-Delete-unused-PNG-images.patch added

- File 0003-Identify-the-subject-and-taskbar-line.patch added

Yuichi HARADA wrote:

Yuichi HARADA wrote:

I created a patch that can dynamically change the start date and due date by moving the bar.

 I incorporated a patch created with #34694#note-3.

 I recreated patch 2024-moving-gantt-bar-v2.patch with git format-patch command.

#127 - 2021-03-25 13:28 - Holger Just

Thank you for your effort in providing and updating this patch! This feature and its UI implementation looks very promising and I would be happy to

see this feature in Redmine soon.
After a quick review, I found some potential issues (in 0001-Moving-gantt-bar.patch however, which may need to be addressed:

The new route is inconsistent with the rest of the routes. It should be under /issues/gantt, i.e.

 

  put '/issues/gantt/:id/change_duration', :to => 'gantts#change_duration', :as => 'gantt_change_duration'

You allow to set any parameter or custom fields to the issue, not just duration related parameters. While the given params appear to be checked

by safe_attributes (which thus probably doesn't cause security issues), this might still be surprising. Maybe it's useful to filter the allowed

parameters?

The view contains A LOT of code which mixes complex Ruby logic and Javascript template generation. It might be helpful to extract the Ruby

parts into a helper and separate the generation of the Javascript response from the Ruby logic. This would also allow to actually test this logic.

In the view, you appear to parse and update generated HTML response code of the Redmine::Helpers::Gantt object as well as directly access

private method and instance variables. This is rather brittle (and slow and potentially insecure). Instead, it's likely a better path to update the

class and add appropriate render methods directly.

Apart from that, it would be very helpful if you could include some tests:

For the controller action, we should at least verify the happy path as well as handling of permissions, conflict handling, and validation errors

The view / helpers should be tested in order to describe the desired behavior (which I find very hard to follow right now).

#128 - 2021-04-22 19:33 - Markus Boremski

+1000

#129 - 2024-03-26 07:55 - Taro Matsuzawa

- File 0001-refs-2024-integrate-gantt-change_duration.patch added

I try re-write patch for 5.1 branch.

fix route to /issues/gantt/:id/change_duration

use permit params

separate ruby logic from view to helper, and fix direct access private method and instance variable

Please give me a feedback!

#130 - 2024-04-13 08:55 - Taro Matsuzawa

Holger Just Mizuki ISHIKAWA Can you review my patch?

Files

gantt-editting-r1928.patch 13.3 KB 2008-10-11 Hiroyuki Yoshioka

gantt-editting-r2478.patch 17.7 KB 2009-02-18 Hiroyuki Yoshioka

gantt-editting-r2645.patch 17.3 KB 2009-04-04 Hiroyuki Yoshioka

gantt-editting-r2671.patch 21.5 KB 2009-04-18 Hiroyuki Yoshioka

gantt-editting-r2671-2.patch 21.7 KB 2009-04-19 Hiroyuki Yoshioka

pb-gantt-edit-r2671.PNG 89.7 KB 2009-04-29 loic Le Gallou

pb-gantt-edit_404err.jpg 20.7 KB 2009-08-12 Andrey Kostrov

gantt-editting-fixed-display-trouble.patch 21.7 KB 2009-10-17 Hiroyuki Yoshioka

gantt-editting-r2924.patch 20.7 KB 2009-10-17 Hiroyuki Yoshioka

gantt_edit_0.9.3_stable_3671.patch 20.7 KB 2010-04-15 Carlos Calvo

gantt_edit_r3764.patch 20.7 KB 2010-05-29 Hiroyuki Yoshioka

gantt_edit_v1-1-0.patch 33.1 KB 2011-02-13 Hiroyuki Yoshioka

gantt_edit_v1-1-1.patch 33.7 KB 2011-02-26 Hiroyuki Yoshioka

gantt_edit_v1-1-1_error.png 79.5 KB 2011-02-28 Chris Darts

gantt_edit_2_v1-1-1.patch 34.5 KB 2011-03-05 Hiroyuki Yoshioka

gantt.rb 48.6 KB 2011-04-22 Masayuki Shibata

gantt-display.png 171 KB 2011-05-17 steve borgelt

gantt_edit_5_v1-1-1.patch 35.5 KB 2011-05-20 Chris Darts

gantt_edit_v1-1-2.patch 53.9 KB 2011-05-29 Hiroyuki Yoshioka

gantt-chart-editing-v1-2-1-src.zip 51.6 KB 2011-10-20 Mitsuo Ohtsuka

gantt_edit_v1-3-3.patch 37.9 KB 2012-06-16 Jun NAITOH

gantt_edit_v1.4.3.patch 39.4 KB 2012-06-16 Toshi MARUYAMA
gantt_edit-trunk-r9835.diff 39.1 KB 2012-06-16 Toshi MARUYAMA

gantt_edit_v1.4.4-ts.patch 42 KB 2012-07-20 Anonymous

gantt_edit.trunk-r10055.diff 45.6 KB 2012-07-20 Toshi MARUYAMA

trunk-r10066.diff 43 KB 2012-07-21 Toshi MARUYAMA

stay.png 25.7 KB 2012-07-21 Toshi MARUYAMA

not-change-color.png 20.8 KB 2012-07-21 Toshi MARUYAMA

2024-moving-gantt-bar.patch 39 KB 2020-11-27 Yuichi HARADA

test-2024-moving-gantt-bar-patch.gif 563 KB 2021-01-19 Mizuki ISHIKAWA

2024-moving-gantt-bar-v2.patch 42.2 KB 2021-02-16 Yuichi HARADA

0001-Moving-gantt-bar.patch 38 KB 2021-02-18 Yuichi HARADA

0002-Delete-unused-PNG-images.patch 5.04 KB 2021-02-18 Yuichi HARADA

0003-Identify-the-subject-and-taskbar-line.patch 4.59 KB 2021-02-18 Yuichi HARADA

0001-refs-2024-integrate-gantt-change_duration.patch 44.5 KB 2024-03-26 Taro Matsuzawa
